#region using
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;

using DShowNET;
#endregion

namespace SoftwareRecorder
{
	/// <summary>
	/// Summary description for QualityConfig.
	/// </summary>
	public class QualityConfig : System.Windows.Forms.Form
	{

		#region Form Variables
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Button buttonCancel;
		private Button buttonOK;
		private System.Windows.Forms.NumericUpDown upDownWidth;
		private System.Windows.Forms.Label labelWidth;
		private System.Windows.Forms.Label labelColorSpace;
		private System.Windows.Forms.Label labelWidthUnit;
		private System.Windows.Forms.Label labelHeightUnit;
		private System.Windows.Forms.Label labelHeight;
		private System.Windows.Forms.CheckBox checkBoxUseDefault;
		private System.Windows.Forms.ComboBox comboBoxColorSpace;
		private System.Windows.Forms.Label labelHeightRange;
		private System.Windows.Forms.Label labelWidthRange;
		private System.Windows.Forms.NumericUpDown upDownHeight;
		#endregion

		#region Constructor / Destructor
		public QualityConfig(ArrayList allMediaTypes, DsUtils.DsAMMediaType defaultMediaType, Quality quality)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.allMediaTypes = allMediaTypes;
			this.defaultMediaType = defaultMediaType;
			this.quality = quality;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(QualityConfig));
			this.labelWidth = new System.Windows.Forms.Label();
			this.labelColorSpace = new System.Windows.Forms.Label();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.buttonOK = new System.Windows.Forms.Button();
			this.comboBoxColorSpace = new System.Windows.Forms.ComboBox();
			this.upDownWidth = new System.Windows.Forms.NumericUpDown();
			this.labelWidthUnit = new System.Windows.Forms.Label();
			this.labelHeightUnit = new System.Windows.Forms.Label();
			this.upDownHeight = new System.Windows.Forms.NumericUpDown();
			this.labelHeight = new System.Windows.Forms.Label();
			this.checkBoxUseDefault = new System.Windows.Forms.CheckBox();
			this.labelHeightRange = new System.Windows.Forms.Label();
			this.labelWidthRange = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.upDownWidth)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.upDownHeight)).BeginInit();
			this.SuspendLayout();
			// 
			// labelWidth
			// 
			this.labelWidth.Location = new System.Drawing.Point(16, 61);
			this.labelWidth.Name = "labelWidth";
			this.labelWidth.Size = new System.Drawing.Size(72, 16);
			this.labelWidth.TabIndex = 3;
			this.labelWidth.Text = "Width:";
			// 
			// labelColorSpace
			// 
			this.labelColorSpace.Location = new System.Drawing.Point(16, 36);
			this.labelColorSpace.Name = "labelColorSpace";
			this.labelColorSpace.Size = new System.Drawing.Size(72, 16);
			this.labelColorSpace.TabIndex = 1;
			this.labelColorSpace.Text = "Color Space:";
			// 
			// buttonCancel
			// 
			this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonCancel.Location = new System.Drawing.Point(192, 160);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.TabIndex = 12;
			this.buttonCancel.Text = "Cancel";
			// 
			// buttonOK
			// 
			this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonOK.Location = new System.Drawing.Point(112, 160);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.TabIndex = 11;
			this.buttonOK.Text = "Ok";
			this.buttonOK.Click += new System.EventHandler(this.buttonOK_Click);
			// 
			// comboBoxColorSpace
			// 
			this.comboBoxColorSpace.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBoxColorSpace.ItemHeight = 13;
			this.comboBoxColorSpace.Location = new System.Drawing.Point(96, 33);
			this.comboBoxColorSpace.Name = "comboBoxColorSpace";
			this.comboBoxColorSpace.Size = new System.Drawing.Size(208, 21);
			this.comboBoxColorSpace.TabIndex = 2;
			this.comboBoxColorSpace.SelectedIndexChanged += new System.EventHandler(this.comboBoxColorSpace_SelectedIndexChanged);
			// 
			// upDownWidth
			// 
			this.upDownWidth.Increment = new System.Decimal(new int[] {
																		  32,
																		  0,
																		  0,
																		  0});
			this.upDownWidth.Location = new System.Drawing.Point(96, 58);
			this.upDownWidth.Maximum = new System.Decimal(new int[] {
																		6400,
																		0,
																		0,
																		0});
			this.upDownWidth.Minimum = new System.Decimal(new int[] {
																		32,
																		0,
																		0,
																		0});
			this.upDownWidth.Name = "upDownWidth";
			this.upDownWidth.Size = new System.Drawing.Size(64, 20);
			this.upDownWidth.TabIndex = 4;
			this.upDownWidth.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.upDownWidth.Value = new System.Decimal(new int[] {
																	  320,
																	  0,
																	  0,
																	  0});
			// 
			// labelWidthUnit
			// 
			this.labelWidthUnit.Location = new System.Drawing.Point(160, 61);
			this.labelWidthUnit.Name = "labelWidthUnit";
			this.labelWidthUnit.Size = new System.Drawing.Size(40, 16);
			this.labelWidthUnit.TabIndex = 5;
			this.labelWidthUnit.Text = "pixels";
			// 
			// labelHeightUnit
			// 
			this.labelHeightUnit.Location = new System.Drawing.Point(160, 85);
			this.labelHeightUnit.Name = "labelHeightUnit";
			this.labelHeightUnit.Size = new System.Drawing.Size(40, 16);
			this.labelHeightUnit.TabIndex = 9;
			this.labelHeightUnit.Text = "pixels";
			// 
			// upDownHeight
			// 
			this.upDownHeight.Increment = new System.Decimal(new int[] {
																		   32,
																		   0,
																		   0,
																		   0});
			this.upDownHeight.Location = new System.Drawing.Point(96, 83);
			this.upDownHeight.Maximum = new System.Decimal(new int[] {
																		 4800,
																		 0,
																		 0,
																		 0});
			this.upDownHeight.Minimum = new System.Decimal(new int[] {
																		 24,
																		 0,
																		 0,
																		 0});
			this.upDownHeight.Name = "upDownHeight";
			this.upDownHeight.Size = new System.Drawing.Size(64, 20);
			this.upDownHeight.TabIndex = 8;
			this.upDownHeight.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.upDownHeight.Value = new System.Decimal(new int[] {
																	   240,
																	   0,
																	   0,
																	   0});
			// 
			// labelHeight
			// 
			this.labelHeight.Location = new System.Drawing.Point(16, 85);
			this.labelHeight.Name = "labelHeight";
			this.labelHeight.Size = new System.Drawing.Size(72, 16);
			this.labelHeight.TabIndex = 7;
			this.labelHeight.Text = "Height:";
			// 
			// checkBoxUseDefault
			// 
			this.checkBoxUseDefault.Location = new System.Drawing.Point(96, 12);
			this.checkBoxUseDefault.Name = "checkBoxUseDefault";
			this.checkBoxUseDefault.Size = new System.Drawing.Size(200, 16);
			this.checkBoxUseDefault.TabIndex = 0;
			this.checkBoxUseDefault.Text = "Use Default Settings";
			this.checkBoxUseDefault.CheckedChanged += new System.EventHandler(this.checkBoxUseDefault_CheckedChanged);
			// 
			// labelHeightRange
			// 
			this.labelHeightRange.AutoSize = true;
			this.labelHeightRange.Location = new System.Drawing.Point(200, 85);
			this.labelHeightRange.Name = "labelHeightRange";
			this.labelHeightRange.Size = new System.Drawing.Size(101, 16);
			this.labelHeightRange.TabIndex = 10;
			this.labelHeightRange.Text = "[labelHeightRange]";
			// 
			// labelWidthRange
			// 
			this.labelWidthRange.AutoSize = true;
			this.labelWidthRange.Location = new System.Drawing.Point(200, 61);
			this.labelWidthRange.Name = "labelWidthRange";
			this.labelWidthRange.Size = new System.Drawing.Size(97, 16);
			this.labelWidthRange.TabIndex = 6;
			this.labelWidthRange.Text = "[labelWidthRange]";
			// 
			// QualityConfig
			// 
			this.AcceptButton = this.buttonOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.buttonCancel;
			this.ClientSize = new System.Drawing.Size(394, 197);
			this.Controls.Add(this.checkBoxUseDefault);
			this.Controls.Add(this.upDownHeight);
			this.Controls.Add(this.labelHeight);
			this.Controls.Add(this.upDownWidth);
			this.Controls.Add(this.buttonCancel);
			this.Controls.Add(this.buttonOK);
			this.Controls.Add(this.labelColorSpace);
			this.Controls.Add(this.comboBoxColorSpace);
			this.Controls.Add(this.labelWidth);
			this.Controls.Add(this.labelHeightRange);
			this.Controls.Add(this.labelWidthRange);
			this.Controls.Add(this.labelHeightUnit);
			this.Controls.Add(this.labelWidthUnit);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "QualityConfig";
			this.ShowInTaskbar = false;
			this.Text = "Edit Capture Settings";
			this.Load += new System.EventHandler(this.QualityConfig_Load);
			((System.ComponentModel.ISupportInitialize)(this.upDownWidth)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.upDownHeight)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		#region Private Variables
		private ArrayList allMediaTypes;
		private Hashtable mediaTypes;
		private DsUtils.DsAMMediaType defaultMediaType;
		private Quality quality;
		#endregion

		#region Private Functions

		string GetNameFromMediaSubType(DsUtils.DsAMMediaType mediaType)
		{
			return GuidHelper.GetGuidName(typeof(MediaSubType), mediaType.MediaType.subType);
		}

		void SetUpDownValues(int width, int height)
		{
			upDownWidth.Value  = 
				width < upDownWidth.Maximum ? (
				width > upDownWidth.Minimum ? 
				width : 
				upDownWidth.Minimum) : 
				upDownWidth.Maximum;
			upDownHeight.Value = 
				height < upDownHeight.Maximum ? (
				height > upDownHeight.Minimum ? 
				height : 
				upDownHeight.Minimum) : 
				upDownHeight.Maximum;
		}

		#endregion

		#region Loading
		private void QualityConfig_Load(object sender, System.EventArgs e)
		{

			if (((Environment.OSVersion.Version.Major > 4) & (Environment.OSVersion.Version.Minor > 0)) & File.Exists(Application.ExecutablePath + ".manifest"))
			{
				for (int i = 0; i < Controls.Count; i++)
				{
					if (Controls[i].GetType().BaseType == typeof(ButtonBase))
					{
						((ButtonBase)Controls[i]).FlatStyle = FlatStyle.System;
					}
				}
			}
			
			mediaTypes = new Hashtable();
			foreach (DsUtils.DsAMMediaType mediaType in allMediaTypes)
			{
				if ((mediaType.videoStreamConfigCaps.MaxOutputSize.X > 0) && 
					(mediaType.videoStreamConfigCaps.MaxOutputSize.Y > 0))
				{
					string colorSpace = GuidHelper.GetGuidName(typeof(MediaSubType), mediaType.MediaType.subType);
					DsUtils.DsAMMediaType existingMediaType = (DsUtils.DsAMMediaType)mediaTypes[colorSpace];
					if (existingMediaType == null)
					{
						existingMediaType = mediaType;
					}
					else
					{
						if (existingMediaType.videoStreamConfigCaps.MinOutputSize.X > mediaType.videoStreamConfigCaps.MinOutputSize.X)
							existingMediaType.videoStreamConfigCaps.MinOutputSize.X = mediaType.videoStreamConfigCaps.MinOutputSize.X;
						if (existingMediaType.videoStreamConfigCaps.MinOutputSize.Y > mediaType.videoStreamConfigCaps.MinOutputSize.Y)
							existingMediaType.videoStreamConfigCaps.MinOutputSize.Y = mediaType.videoStreamConfigCaps.MinOutputSize.Y;
						if (existingMediaType.videoStreamConfigCaps.MaxOutputSize.X < mediaType.videoStreamConfigCaps.MaxOutputSize.X)
							existingMediaType.videoStreamConfigCaps.MaxOutputSize.X = mediaType.videoStreamConfigCaps.MaxOutputSize.X;
						if (existingMediaType.videoStreamConfigCaps.MaxOutputSize.Y < mediaType.videoStreamConfigCaps.MaxOutputSize.Y)
							existingMediaType.videoStreamConfigCaps.MaxOutputSize.Y = mediaType.videoStreamConfigCaps.MaxOutputSize.Y;
					}
					mediaTypes[colorSpace] = existingMediaType;
				}
			}
			ArrayList keys = new ArrayList(mediaTypes.Keys);
			keys.Sort();
			foreach (string key in keys)
			{
				comboBoxColorSpace.Items.Add(GetNameFromMediaSubType((DsUtils.DsAMMediaType)mediaTypes[key]));
			}

			if (quality == null)
			{
				checkBoxUseDefault.Checked = true;
			}
			else
			{
				comboBoxColorSpace.Text = quality.colorSpace;
				SetUpDownValues(quality.width, quality.height);
			}
		}
		#endregion

		#region Unloading
		private void buttonOK_Click(object sender, System.EventArgs e)
		{
			if (checkBoxUseDefault.Checked)
				quality = null;
			else
			{
				if (quality == null)
					quality = new Quality();

				quality.colorSpace = comboBoxColorSpace.Text;
				quality.width = (int)upDownWidth.Value;
				quality.height = (int)upDownHeight.Value;
			}
		}

		public Quality GetQuality()
		{
			return quality;
		}
		#endregion

		#region Events
		
		private void checkBoxUseDefault_CheckedChanged(object sender, System.EventArgs e)
		{
			comboBoxColorSpace.Enabled = !checkBoxUseDefault.Checked;
			upDownWidth.Enabled = !checkBoxUseDefault.Checked;
			upDownHeight.Enabled = !checkBoxUseDefault.Checked;

			if (checkBoxUseDefault.Checked)
			{
				comboBoxColorSpace.Text = GetNameFromMediaSubType(defaultMediaType);
				SetUpDownValues(defaultMediaType.videoInfoHeader.BmiHeader.Width, defaultMediaType.videoInfoHeader.BmiHeader.Height);
			} 
			else if (quality != null)
			{
				comboBoxColorSpace.Text = quality.colorSpace;
				SetUpDownValues(quality.width, quality.height);
			}
		}

		private void comboBoxColorSpace_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DsUtils.DsAMMediaType mediaType = (DsUtils.DsAMMediaType)mediaTypes[comboBoxColorSpace.Text];

			upDownWidth.Minimum = mediaType.videoStreamConfigCaps.MinOutputSize.X;
			upDownWidth.Maximum = mediaType.videoStreamConfigCaps.MaxOutputSize.X;
			upDownWidth.Increment = mediaType.videoStreamConfigCaps.OutputGranularityX;

			upDownHeight.Minimum = mediaType.videoStreamConfigCaps.MinOutputSize.Y;
			upDownHeight.Maximum = mediaType.videoStreamConfigCaps.MaxOutputSize.Y;
			upDownHeight.Increment = mediaType.videoStreamConfigCaps.OutputGranularityY;

			labelWidthRange.Text = 
				mediaType.videoStreamConfigCaps.MinOutputSize.X + " -> " + 
				mediaType.videoStreamConfigCaps.MaxOutputSize.X + " (" + 
				mediaType.videoInfoHeader.BmiHeader.Width + " default, steps of " +
				mediaType.videoStreamConfigCaps.OutputGranularityX + ")";

			labelHeightRange.Text = 
				mediaType.videoStreamConfigCaps.MinOutputSize.Y + " -> " + 
				mediaType.videoStreamConfigCaps.MaxOutputSize.Y + " (" + 
				mediaType.videoInfoHeader.BmiHeader.Height + " default, steps of " + 
				mediaType.videoStreamConfigCaps.OutputGranularityY + ")";
		}

		#endregion

	}
}
